#ifndef __new_quick_watch_dlg__
#define __new_quick_watch_dlg__

/**
@file
Subclass of NewQuickWatch, which is generated by wxFormBuilder.
*/

#include "newquickwatch.h"
#include <wx/timer.h>
#include "debugger.h"
#include <map>
#include "debuggerobserver.h"

class wxTimer;

/** Implementing NewQuickWatch */
class DisplayVariableDlg : public NewQuickWatch
{
public:
	IDebugger*                       m_debugger;
	std::map<wxString, wxTreeItemId> m_gdbId2Item;
	std::map<wxString, wxTreeItemId> m_gdbId2ItemLeaf;
	wxString                         m_mainVariableObject;
	wxString                         m_variableName;
	wxString                         m_expression;
	wxTimer*                         m_timer2;
	wxTimer*                         m_mousePosTimer;
	wxString                         m_fullpath;
	wxTreeItemId                     m_hoveredItem;
	wxString                         m_itemOldValue;
	bool                             m_keepCurrentPosition;
	
	
protected:
	bool     IsFakeItem(const wxTreeItemId &item);
	wxString DoGetItemPath(const wxTreeItemId &item);
	void     DoAdjustPosition();
	void     DoEditItem(const wxTreeItemId &item);
protected:
	// Handlers for NewQuickWatch events.
	void OnExpandItem  ( wxTreeEvent& event );
	void OnItemExpanded( wxTreeEvent& event );
	void OnBtnCancel(wxCommandEvent &e);
	void OnCloseEvent(wxCloseEvent &e);
	void DoAddChildren(wxTreeItemId &item, const VariableObjChildren &children);
	void OnKeyDown(wxKeyEvent &event);
	void DoCleanUp();
	void OnLeftDown(wxMouseEvent &e);
	void OnTimer2(wxTimerEvent &e);
	void OnCheckMousePosTimer(wxTimerEvent &e);
	void OnItemMenu(wxTreeEvent& event);
	void OnMenuSelection(wxCommandEvent &e);
	void OnMouseMove( wxMouseEvent& event );

public:
	/** Constructor */
	DisplayVariableDlg( wxWindow* parent);
	virtual ~DisplayVariableDlg();

	void AddItems   ( const wxString &varname, const VariableObjChildren &children);
	void UpdateValue( const wxString &varname, const wxString &value);
	void BuildTree  (const VariableObjChildren &children, IDebugger *debugger);
	void HideDialog ();
	void ShowDialog (bool center);
	void OnCreateVariableObjError(const DebuggerEvent &event);

};

#endif // __new_quick_watch_dlg__
